
b_civilian =
{
---------------------
--CIVILIAN BEHAVIOR--
---------------------
-----TURN BASED------
---------------------
	checkForDisappear = function(id)
		if(service.isUnitInBlackZone(id)) then
			log(id,"*** Disappear now...")
			endOfTurn(id)
			setPersonParameter(id, "HEALTH", 0)
			Sectors[CUR_MISSION.Name].onKill()
			local rel = relations(team(id),PLAYER)
			sendMessage(rel.."_disappeared", NEW_ENTRY)
			disappear(id)
			log(id,"*** Disappear done.")
			return(true)
		end
		return(false)
	end,


	tb_think = function(id, strategy, time)
calls.enter("b_civilian.tb_think",id..","..strategy)
		log(id, "TURN BASED: I AM JUST A CIVILIAN")

		sounds.resortSounds(id)

		local human = Humans[id]
		Humans[id].attacked = false

		local visible_target = service.closestVisibleEnemy(id)
		local known_target = memory.getClosestKnownEnemy(id)
		local lx, ly, lz, lf = getPosition(id)
		local dist = 0
		local movedist = getAIConst().defMoveDist
		local minusone = -1
		local ret = false

		if(not isUnitValid(visible_target)) then
		--    
			log(id, "  ")

			if (known_target == nil) then
				log(id, "  ,  ...")
				local sound = sounds.getDangerousSound(id)
				if((sound~=nil) and (Humans[id].priority <= 0.1)) then 			--   
					local sdist = service.person2point_distance(id, sound.x, sound.y, sound.z)
					log(id, "  ",sound.type,sdist)
					if((math.random()<0.5) and (getPersonPose(id)~="lie")) then
						ret = addRotate(id, sound.x, sound.y, sound.z, getAIConst().rotateMistake)
					end
					if(sounds.isSoundDangerous(sound.type,sdist)) then
						log(id, " !")
						if((math.random()<0.5) and poseDown(id)) then
							ret = true
						end
					end
					sounds.removeLastSound(id)
				elseif(isUnitValid(Humans[id].hurt)) then		--   
					local hx, hy, hz, hf = getPosition(Humans[id].hurt)
					log(id, "  ")
					ret = addRotate(id, hx, hy, hz)
					if(poseDown(id)) then 
						ret = true
					end
					Humans[id].hurt = NONE
				elseif ((idle(id)) and (Humans[id].status == "GREEN")) then
					log(id, " !")
					if ((service.isPatrol(id) == true) and isValid(Humans[id].patrol_routine)) then
					--       
						local res = b_patrol.think(id, time, strategy)
calls.leave("b_civilian.tb_think",id..","..strategy)
						return(res)
					end
					ret = poseUp(id)
				end
			else
				Humans[id].priority = 0.5
				log(id, "  : "..known_target.id)
				if (Humans[id].behavior == "home") then
					log(id, "     !")
					if (getPersonPose(id) ~= "sit") then
						ret = addPose(id, "sit")
					end
				else
					if(b_civilian.checkForDisappear(id)) then
calls.leave("b_civilian.tb_think",id..","..strategy)
						return(0)
					end
					dist = service.person2point_distance(id, known_target.x, known_target.y, known_target.z)
					movedist = b_soldier.selectMoveDistFromStrategy(id,strategy)
					lx, ly, lz = service.pointAlongPointToPersonLine(known_target.x, known_target.y, known_target.z, id, movedist * minusone)
					ret = true
					if (dist < 30) then
						log(id, "!    !")
						if (math.random() > 0.75) then
							log(id, "  !")
							addSmartMove(id, "run", lx, ly, lz, lf)
							Humans[id].moveonly = true
							local count = math.random(5)
							local remark = "civilian_panic_0"..count
							service.showAck(id,remark,0.5)
						else
							if (getPersonPose(id) == "lie") then
								movedist = movedist * minusone / 3
							elseif (getPersonPose(id) == "sit") then
								movedist = movedist * minusone / 2
							elseif (getPersonPose(id) == "stand") then
								movedist = movedist * minusone / 1.5
							end
							lx, ly, lz = service.pointAlongPointToPersonLine(known_target.x, known_target.y, known_target.z, id, movedist)
							addSmartMove(id, "move", lx, ly, lz, lf)
							Humans[id].moveonly = true
						end
					elseif (dist < 50) then
						log(id, "!   !")
						addSmartMove(id, "run", lx, ly, lz, lf)
						Humans[id].moveonly = true
					elseif (dist < 75) then
						log(id, " .   !")
						lx, ly, lz = service.pointAlongPointToPersonLine(known_target.x, known_target.y, known_target.z, id, movedist * minusone / 1.5)
						addSmartMove(id, "walk", lx, ly, lz, lf)
						Humans[id].moveonly = true
					elseif (dist > 75) then
						log(id, " ,   !")
						ret = false
						if (getPersonPose(id) ~= "sit") then
							ret = addPose(id, "sit")
						end
					end
				end
			end
		else
		--    
			human.priority = 0.8
			log(id, "  : "..visible_target)
			ret = true
			if (Humans[id].behavior == "home") then
				lx, ly, lz, lf = getPosition(visible_target)
				log(id, "     !")
				ret = addRotate(id, lx, ly, lz)
				if (getPersonPose(id) ~= "sit") then
					ret = addPose(id, "sit") or ret
				end
			else
				if(b_civilian.checkForDisappear(id)) then
calls.leave("b_civilian.tb_think",id..","..strategy)
					return(0)
				end
				service.reportEnemy2Friends(id, visible_target, getAIConst().visibleReportProb)
        			dist = service.person2person_distance(id, visible_target)
        			movedist = b_soldier.selectMoveDistFromStrategy(strategy)
				lx, ly, lz = service.pointAlongPersonToPersonLine(visible_target, id, movedist * minusone)
        			if(dist < 30) then
        				if(math.random() > 0.75) then
						log(id, "  !")
						ret = false
					else
						log(id, "!   !")
						addSmartMove(id, "run", lx, ly, lz, lf)
						Humans[id].moveonly = true
					end
				elseif (dist < 50) then
					log(id, "!    !")
					if(math.random() > 0.75) then
						log(id, "  !")
						addSmartMove(id, "run", lx, ly, lz, lf)
						Humans[id].moveonly = true
						local count = math.random(5)
						local remark = "civilian_panic_0"..count
						service.showAck(id,remark,0.5)
					else
						lx, ly, lz = service.pointAlongPersonToPersonLine(visible_target, id, movedist * minusone / 2)
						addSmartMove(id, "sneak", lx, ly, lz, lf)
						Humans[id].moveonly = true
					end
				elseif (dist < 75) then
					log(id, " !  !")
					addSmartMove(id, "run", lx, ly, lz, lf)
					Humans[id].moveonly = true
				elseif (dist > 75) then
					log(id, " ,  ")
					ret = false
					if (getPersonPose(id) ~= "lie") then
						ret = addPose(id, "lie")
					end
				end
			end
		end
calls.leave("b_civilian.tb_think",id..","..strategy)
		if(ret) then
			return 1
		end
		return 0
	end,
---------------------
------REAL TIME------
---------------------	
	rt_think = function(id, time)
calls.enter("b_civilian.rt_think",id)
		log(id, "REAL TIME: I AM JUST A CIVILIAN")
		local human = Humans[id]

		local known_target = memory.getClosestKnownEnemy(id)
		local lx, ly, lz, lf = getPosition(id)
		local dist = 0
		local movedist = getAIConst().defMoveDist
		local minusone = -1
		local ret = false

		if(known_target == nil) then
		--    
			log(id, "  ,  ...")
			Humans[id].priority = 0

			local sound = sounds.getDangerousSound(id)
			if((sound~=nil) and (Humans[id].priority <= 0.1)) then 			--   
				local sdist = service.person2point_distance(id, sound.x, sound.y, sound.z)
				log(id, "  ")
				if(math.random()<0.5) then
					ret = addRotate(id, sound.x, sound.y, sound.z, getAIConst().rotateMistake)
				end
				if(sounds.isSoundDangerous(sound.type,sdist)) then
					log(id, " !")
					if((math.random()<0.5) and poseDown(id)) then
						ret = true
					end
				end
				sounds.removeLastSound(id)
			elseif(idle(id)) then
				log(id, " !")
				if(service.isPatrol(id) and isValid(Humans[id].patrol_routine)) then
					local res = b_patrol.think(id, time)
calls.leave("b_civilian.rt_think",id)
					return(res)
				end
				ret = poseUp(id)
			end
		elseif(idle(id)) then
			Humans[id].priority = 0.5
			clearAllOrders(id)
			log(id, " ")
			log(id, "  : ",known_target.id)
			if (Humans[id].behavior == "home") then
				log(id, "     !")
				if (getPersonPose(id) ~= "sit") then
					ret = addPose(id, "sit")
				end
			else
				ret = true
				dist = service.person2point_distance(id, known_target.x, known_target.y, known_target.z)
				movedist = getAIConst().maxMoveDist
				lx, ly, lz = service.pointAlongPointToPersonLine(known_target.x, known_target.y, known_target.z, id, movedist * minusone)

				if (dist < 30) then
					log(id, "!    !")
					if(math.random() > 0.75) then
						log(id, "  !")
						addSmartMove(id, "run", lx, ly, lz, lf)
					else
						if (getPersonPose(id) == "lie") then
							movedist = movedist * minusone / 3
						elseif (getPersonPose(id) == "sit") then
							movedist = movedist * minusone / 2
						elseif (getPersonPose(id) == "stand") then
							movedist = movedist * minusone / 1.5
						end
						lx, ly, lz = service.pointAlongPointToPersonLine(known_target.x, known_target.y, known_target.z, id, movedist * minusone / 1.5)	
						addSmartMove(id, "move", lx, ly, lz, lf)
					end
				elseif (dist < 50) then
					log(id, "!   !")
					addSmartMove(id, "run", lx, ly, lz, lf)
				elseif (dist < 75) then
					log(id, " .   !")
					lx, ly, lz = service.pointAlongPointToPersonLine(known_target.x, known_target.y, known_target.z, id, movedist * minusone / 1.5)
					addSmartMove(id, "walk", lx, ly, lz, lf)
				elseif (dist > 75) then
					log(id, " ,   !")
					ret = false
					if (getPersonPose(id) ~= "sit") then
						ret = addPose(id, "sit")
					end
				end
			end
       		else
			log(id, " ,  !")
calls.leave("b_civilian.rt_think",id)
			return 2
		end
calls.leave("b_civilian.rt_think",id)
                if(ret) then
			return 1
		end
		return 0
	end,
}