--------------------------------------------------------------------------------
--AG: 30.05.2006
--Model of the behavior: SNIPER (behavior = sniper)
--1. sniper always shoots single (except CQB: cqb_distance) and only sitting
--2. sniper approaches the target only if it's too far and only if it cannot get a clear shot (tries, far_distance).
--3. sniper changes position if it cannot shoot the target it is located closely to it (far_distance).
--4. sniper changes position after 5 attacks from the current position.
--5. only in the step-by-step regime and only with the visible target, if there is no visible target - it acts as usual soldier.
--------------------------------------------------------------------------------

b_sniper = 
{
	selectMoveDistFromStrategy = function(id,strategy)
		local breath = getPersonParameter(id, "BREATH")
		local movedist = getAIConst().sniperMaxMoveDist
		if(isGameInRT()) then
			strategy = math.random(0,3)	
		end
		if(strategy == 1) or (breath < 500) then
			movedist = getAIConst().sniperMinMoveDist
		elseif(strategy == 2) or (breath < 1000) then
			movedist = getAIConst().sniperDefMoveDist
		elseif(strategy > 2) or (breath < 1500) then
			movedist = getAIConst().sniperMedMoveDist
		end
		return(movedist)
	end,

----------------------------
--SOLDIER SNIPER BEHAVIOR--
----------------------------
	think = function(id, strategy, visible_target)
		log(id, "I AM THE SNIPER")
		calls.enter("b_sniper.think",id..","..strategy..","..visible_target)
		local attacks_before_shift = getAIConst().sniperMaxAttacks	-- how many attacks it is possible to make before the change of position
		local tries = getAIConst().sniperMaxMissTries			-- how many attempt it is possible to make to the change of position or target approach
                local meleehack = false
		log(id, "Visble target:", visible_target)
                

		if not(service.isTargetDangerous(visible_target)) then
			log(id, "Current target", visible_target,"is not dangerous. We will search for a dangerous one.")
			local new_dangerous_target = service.closestDangerousEnemy(id)
                       	local harmless_target = service.closestHarmlessEnemy(id)
 			local dist_c = service.person2person_distance(id, visible_target)
	 	        if (isUnitValid(dangerous_target) and isUnitValid(harmless_target)) then
                	       	local dist_d = service.person2person_distance(id, dangerous_target)
                        	local dist_h = service.person2person_distance(id, harmless_target)
                               	if (dist_h *2) < dist_d then 
                               		visible_target = harmless_target
                                        meleehack = (((dist_h < getAIConst().forcedMeleeDist * 1.5) and (math.random() < getAIConst().forcedMeleeProb)) or dist_h < 5 )
                               	elseif not((dist_c *2) < dist_d) then
                               		visible_target = new_dangerous_target
                                        meleehack = (((dist_d < getAIConst().forcedMeleeDist) and (math.random() < getAIConst().forcedMeleeProb)) or dist_d < 3)
                              	end
                        elseif isUnitValid(dangerous_target) then
                               	local dist_d = service.person2person_distance(id, dangerous_target)
                        	if not((dist_c *2) < dist_d) then 
                               		 visible_target = new_dangerous_target
                                         meleehack = (((dist_d < getAIConst().forcedMeleeDist) and (math.random() < getAIConst().forcedMeleeProb)) or dist_d < 3)
                               	end 
                      	elseif isUnitValid(harmless_target) then
                               	local dist_h = service.person2person_distance(id, harmless_target)
                               	if not((dist_c *2) < dist_h) then 
                                   	visible_target = harmless_target
                                        meleehack = (((dist_h < getAIConst().forcedMeleeDist * 1.5) and (math.random() < getAIConst().forcedMeleeProb)) or dist_h < 5)
                               	end 
                       	else
                                        meleehack = (((dist < getAIConst().forcedMeleeDist * 1.5) and (math.random() < getAIConst().forcedMeleeProb)) or dist < 5)
                        end
 		else
			log(id, "Current target", visible_target, "is dangerous")
			Humans[visible_target].dangerous = true
			local morale = getPersonParameter(id, "MORALE")
			if(not b_soldier.isBrave(id) and ((service.getEATandFATInRange(id,visible_target,6) * 10) > morale) and (math.random()<0.4) and (dist < 30)) then
				log(id, "Go-go-go away!!!")
				local movedist = b_soldier.selectMoveDistFromStrategy(id,strategy)
				local lx, ly, lz = service.pointAlongPersonToPersonLine(target, id, -1*movedist)
				addSmartMove(id, b_soldier.selectMoveType(id, false), lx, ly, lz, 1)
				Humans[id].attacked = false
				Humans[id].moveonly = true
               		else
               			log(id, "We don't flee yet")
        		end  
		end

		local tx, ty, tz, tf = getPosition(visible_target)
		local dist = service.person2person_distance(id, visible_target)
		local movedist = b_sniper.selectMoveDistFromStrategy(id,strategy)

                if(meleehack) then
			log(id,"Try melee (Sniper)")
 			b_soldier.attackTargetByMeleeOrFlee(id,visible_target,strategy)
			calls.leave("b_sniper.think",id..","..strategy..","..visible_target)
			return 1
                end

		if (Humans[id].shift > attacks_before_shift) then
			Humans[id].shift = 0
		end


		local isNewTarget = false
		if (Humans[id].shift == 0) then
		-- it is necessary to change the position
			log(id, "I change position now")
			addRotate(id,tx, ty, tz)
			movedist = movedist * 3
			local dir = "left"
			if (math.random() > 0.5) then
				dir = "right"
			end
			local nx, ny, nz, nf = service.randomSidePoint(id, dir, movedist)
                        if(Humans[id].visibleAtLastTurn) then
				addSmartMove(id, "run", nx, ny, nz, nf)
                        else
				addSmartMove(id, "sneak", nx, ny, nz, nf)
                        end
			Humans[id].moveonly = true
			Humans[id].attacked = false
			Humans[id].shift = 1
			calls.leave("b_sniper.think",id..","..strategy..","..visible_target)
			return 1
		else
		--It is not possible to change position
			if((not isUnitValid(Humans[id].current_target)) or (visible_target ~= Humans[id].current_target)) then
				log(id, "This is a new target")
				isNewTarget = true
				Humans[id].current_target = visible_target
				Humans[id].target_health = getPersonParameter(visible_target, "HEALTH")
				Humans[id].try = 0
				Humans[id].attacked = false
				Humans[id].shift = 1
			elseif (visible_target == Humans[id].current_target) then
				log(id, "I check this target stats")
				local target_health = getPersonParameter(visible_target, "HEALTH")
				if (Humans[id].target_health > target_health) then
					log(id, "The health of the target changed")
					if (Humans[id].attacked) then
						log(id, "I wounded it, mean i could hit it")
						Humans[id].shift = Humans[id].shift + 1
						Humans[id].try = 0
						Humans[id].target_health = target_health
					else
						log(id, "Someone else attacked it")
					end
				else
					log(id, "The health of target unchanged")
					if(Humans[id].attacked) then
						log(id, "I missed or could not reach it")

						Humans[id].shift = Humans[id].shift + 1
						Humans[id].try = Humans[id].try + 1

						if(not inRange(id, visible_target)) then
							log(id, "Not in range, need get closer")
							local nx, ny, nz = service.pointAlongPersonToPersonLine(visible_target, id, movedist)
							Humans[id].try = 0
							Humans[id].shift = 1
                        				if(Humans[id].visibleAtLastTurn) then
								addSmartMove(id, "run", nx, ny, nz, 1)
                        				else
								addSmartMove(id, "sneak", nx, ny, nz, 1)
                      					end
							Humans[id].moveonly = true
							Humans[id].attacked = false
							calls.leave("b_sniper.think",id..","..strategy..","..visible_target)
							return 1
						elseif((dist < grenadeMaxDistance(id)) and (takeAP(id)>10)) then
							if(not b_soldier.attackTargetByGrenade(id,visible_target)) then
								log(id, "The target is too close, need some space between us")
								local movedist = b_soldier.selectMoveDistFromStrategy(id,strategy)
								local nx, ny, nz = service.pointAlongPersonToPersonLine(visible_target, id, -1*movedist)
								Humans[id].try = 0
								Humans[id].shift = 1
								addSmartMove(id, "run", nx, ny, nz, 1)
								if(b_soldier.isLastMove(id,strategy,movedist)) then
									addPose(id, "sit")
									Humans[id].turnDone = true
								end
								Humans[id].moveonly = true
								Humans[id].attacked = false
							end	
							calls.leave("b_sniper.think",id..","..strategy..","..visible_target)
							return 1
						elseif(Humans[id].try < tries) then
							log(id, "It is possible to shoot again")
						else
							log(id, "We are out of attempts, time to change position")
							Humans[id].current_target = NONE
							Humans[id].target_health = 0
							Humans[id].shift = 0
							Humans[id].attacked = false
							calls.leave("b_sniper.think",id..","..strategy..","..visible_target)
							return 2
						end
					else
						log(id, "I could not attack")
					end
				end
			end

			if(service.isFriendInLos(id, visible_target)) then
				Humans[id].current_target = NONE
				Humans[id].target_health = 0
				Humans[id].shift = 0
				Humans[id].attacked = false
				calls.leave("b_sniper.think",id..","..strategy..","..visible_target)
				return 2
			end
			if((not isNewTarget) and (getPersonPose(id) == "stand")) then
				addPose(id, "sit")
			end
			service.selectFireMode(id, visible_target, dist, strategy)
			local aimLevel = b_soldier.selectAimLevelFromStrategy(id,dist,strategy)		
			log(id, "Selecting the aim level", aimLevel)
			attackTarget(id, visible_target, aimLevel)
			if((strategy >= getAIConst().maxStrategy) and (getPersonPose(id) == "stand")) then
 				log(id,"**** max strategy, sitdown")
				addPose(id, "sit")
			end
			Humans[id].attacked = true
			Humans[id].moveonly = false
			calls.leave("b_sniper.think",id..","..strategy..","..visible_target)
			return 1
		end
		calls.leave("b_sniper.think",id..","..strategy..","..visible_target)
		return 0
	end,
------------------------------------------------------------------------------------------	
}